RWA = LibStub("AceAddon-3.0"):NewAddon("RWA", "AceConsole-3.0", "AceEvent-3.0");
local _G = getfenv()
threatData = {}

local ThreatLib = LibStub:GetLibrary("LibThreatClassic2")

local _UnitThreatSituation = function (unit, mob)
    return ThreatLib:UnitThreatSituation (unit, mob)
end

local _UnitDetailedThreatSituation = function (unit, mob)
    return ThreatLib:UnitDetailedThreatSituation (unit, mob)
end

local core = CreateFrame("FRAME");
core:RegisterEvent("ADDON_LOADED");
core:RegisterEvent("PLAYER_LOGOUT");


function RWA:DrawGUI()

local AceGUI = LibStub("AceGUI-3.0")
local gui = AceGUI:Create("Frame")
gui:SetTitle("RWA Configuration")
gui:SetStatusText("Created by Helénantal - Mirage-Raceway")
gui:SetWidth(450)
gui:SetHeight(420)

	--Siren Alarm
    local checkbox_alarm = AceGUI:Create("CheckBox")
    checkbox_alarm:SetValue()
    checkbox_alarm:SetType("checkbox")
    checkbox_alarm:SetLabel("Enable Alarm")
	checkbox_alarm:SetWidth(400)
	checkbox_alarm:SetDescription("Audio alerts for Threat Warnings\n and if your target's target is You.")
    checkbox_alarm:SetPoint("TOPLEFT",3,-3)
    checkbox_alarm:SetCallback("OnValueChanged", function() alarm = checkbox_alarm:GetValue() end)
	gui:AddChild(checkbox_alarm)

		--Handler
		if alarm then
		checkbox_alarm:SetValue(alarm)
		else
		checkbox_alarm:SetValue(alarm)
		end
	
	--Beware Sound
	local checkbox_beware = AceGUI:Create("CheckBox")
    checkbox_beware:SetValue()
    checkbox_beware:SetType("checkbox")
    checkbox_beware:SetLabel("Enable Beware Sound")
	checkbox_beware:SetWidth(400)
	checkbox_beware:SetDescription("Classic DBM Like Voice notifications\n when your target's target is You.")
    checkbox_beware:SetPoint("TOPLEFT",3,-3)
    checkbox_beware:SetCallback("OnValueChanged", function() beware = checkbox_beware:GetValue() end)
	gui:AddChild(checkbox_beware)
	
		--Handler
		if beware then
		checkbox_beware:SetValue(beware)
		else
		checkbox_beware:SetValue(beware)
		end
	
	--Text Notice	
	local checkbox_textNotice = AceGUI:Create("CheckBox")
    checkbox_textNotice:SetValue()
    checkbox_textNotice:SetType("checkbox")
    checkbox_textNotice:SetLabel("Enable Text Warnings")
	checkbox_textNotice:SetWidth(400)
	checkbox_textNotice:SetDescription("Text notifications when the Threat treshold exceeded\n -Realtime threat informations in % in the Chat Frame\n -And if you target's target is You.")
    checkbox_textNotice:SetPoint("TOPLEFT",3,-3)
    checkbox_textNotice:SetCallback("OnValueChanged", function() textNotice = checkbox_textNotice:GetValue() end)
	gui:AddChild(checkbox_textNotice)
	
		--Handler
		if textNotice then
		checkbox_textNotice:SetValue(textNotice)
		else
		checkbox_textNotice:SetValue(textNotice)
		end
		
	--Enable Screen Flashing
	local checkbox_flash = AceGUI:Create("CheckBox")
    checkbox_flash:SetValue()
    checkbox_flash:SetType("checkbox")
    checkbox_flash:SetLabel("Enable Flash Vignette Effects")
	checkbox_flash:SetWidth(400)
	checkbox_flash:SetDescription("Adds a soft vignette overlay to your screen for inform you discreetly\n -Red vignette: Target is Attacking You!\n -Blue vignette: Threat treshold exceeded.")
    checkbox_flash:SetPoint("TOPLEFT",3,-3)
    checkbox_flash:SetCallback("OnValueChanged", function() flashing = checkbox_flash:GetValue() end)
	gui:AddChild(checkbox_flash)
	
		--Handler
		if flashing then
		checkbox_flash:SetValue(flashing)
		else
		checkbox_flash:SetValue(flashing)
		end
		
	--Enable Threat Alerts
	local checkbox_threat = AceGUI:Create("CheckBox")
    checkbox_threat:SetValue()
    checkbox_threat:SetType("checkbox")
    checkbox_threat:SetLabel("Enable High Threat Warnings")
	checkbox_threat:SetWidth(400)
	checkbox_threat:SetDescription("Threat Analysis for Combat Situations\n Your Party/Raid members must have ThreatClassic2 Addon installed for the best results.\n If the Tanking person doesn't have ThreatClassic2 installed\n The measurement will be Wrong!\n A notification(s) must be enabled to inform you somehow.")
    checkbox_threat:SetPoint("TOPLEFT",3,-3)
    checkbox_threat:SetCallback("OnValueChanged", function() threatwarnings = checkbox_threat:GetValue() end)
	gui:AddChild(checkbox_threat)
	
		--Handler
		if threatwarnings then
		checkbox_threat:SetValue(threatwarnings)
		else
		checkbox_threat:SetValue(threatwarnings)
		end
		
	--Threat Treshold

	local treshold_threat = AceGUI:Create("EditBox")
	treshold_threat:SetText(threattreshold)
	treshold_threat:SetLabel("Threat Treshold %")
	treshold_threat:SetWidth(95)
	treshold_threat:SetCallback("OnEnterPressed", function(widget, event, text) 
	
	threattreshold = tonumber(text) 
	
	
		if (threattreshold > 95) then
		threattreshold = 95
		print("<RWA> Too High value entered. Changing back to 95%")
		else
		threattreshold = text
		end
		
	
	end)
	
	gui:AddChild(treshold_threat)
	
		--Handler
		if (threattreshold ~= nil) then
			--if nil then don't do anything.
		else
			if threattreshold then
			treshold_threat:SetValue(threattreshold)
			else
			treshold_threat:SetValue(threattreshold)
			end	
		end
		
	--Raid Only (Not yet implemented!)
	--local checkbox_ron = AceGUI:Create("CheckBox")
    --checkbox_ron:SetValue()
    --checkbox_ron:SetType("checkbox")
    --checkbox_ron:SetLabel("Raid Only")
    --checkbox_ron:SetPoint("TOPLEFT",3,-3)
    --checkbox_ron:SetCallback("OnValueChanged", function() raidonly = checkbox_ron:GetValue() end)
	--gui:AddChild(checkbox_ron)
	
		--Handler
		--if raidonly then
		--checkbox_ron:SetValue(raidonly)
		--else
		--checkbox_ron:SetValue(raidonly)
		--end
	
end

SLASH_RWA1 = "/rwa"
SlashCmdList["RWA"] = function(msg, editBox)
RWA:DrawGUI();
end

function RWA:OnInitialize()
		RaidNotice_AddMessage(RaidWarningFrame, "Rewind Aggro Alert v0.22 by Helénantal - Mirage Raceway", ChatTypeInfo["RAID_WARNING"])
		RaidNotice_AddMessage(RaidWarningFrame, "Use /rwa for some magic.", ChatTypeInfo["RAID_WARNING"])
end
 
function ThreatAlert()
local isTanking, status, threatpct, rawthreatpct, threatvalue = _UnitDetailedThreatSituation ("player", "target")

	if (threatpct ~= nil) then
		if textNotice then
			print("<RWA> Your actual threat:", math.floor(threatpct+0.5), "%")
			RaidNotice_AddMessage(RaidWarningFrame,"WARNING: Threat Treshold has been exceeded!",{r=1.0,g=0.75,b=0})
		end
			if alarm then
			PlaySoundFile("Interface\\AddOns\\RWA\\assets\\highThreat.ogg")
			end
	end
	
end


function RWA:OnEnable()
self:Print("/rwa for configuration")

local frame = CreateFrame("Frame")

-- The minimum number of seconds between each update
local ONUPDATE_INTERVAL = 0.1

-- The number of seconds since the last update
local TimeSinceLastUpdate = 0
frame:SetScript("OnUpdate", function(self, elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	if TimeSinceLastUpdate >= ONUPDATE_INTERVAL then
		TimeSinceLastUpdate = 0				
			--Ha target targete, a jatekos
			local playerName = UnitName("player");
			local targetTarget = UnitName("targettarget");	
			local target = UnitName("target");
			local inRaid = UnitInRaid("player")
			local unitclass = UnitClassification("target");
			local isTanking, status, threatpct, rawthreatpct, threatvalue = _UnitDetailedThreatSituation ("player", "target")

			if not (playerName == targetTarget) then
					if threatwarnings then
						if UnitAffectingCombat("player") then
						--Threat
						
						--Nil Check
						if (threatpct ~= nil) then
						
							if (tostring(threatpct) > tostring(threattreshold)) then

							if not self.AggroFrame then
							local aggro = CreateFrame("Frame", "RWAAggroFrame")
							aggro:SetToplevel(true)
							aggro:SetFrameStrata("FULLSCREEN_DIALOG")
							aggro:SetAllPoints(UIParent)
							aggro:EnableMouse(false)
							aggro:Hide()
							aggro.texture = aggro:CreateTexture(nil, "BACKGROUND")
							aggro.texture:SetTexture("Interface\\FullScreenTextures\\OutOfControl")
							aggro.texture:SetAllPoints(UIParent)
							aggro.texture:SetBlendMode("ADD")
							aggro:SetScript("OnShow", function(self)
								self.elapsed = 0
								self:SetAlpha(0)
							end)
							aggro:SetScript("OnUpdate", function(self, elapsed)
								elapsed = self.elapsed + elapsed
								if elapsed < 2 then
									if flashing then

										local alpha = elapsed % 1.3
										if not (UnitName("player") == UnitName("target")) then
												if alpha < 0.15 then
													self:SetAlpha(alpha / 0.15)
												elseif alpha < 0.9 then
													self:SetAlpha(1 - (alpha - 0.15) / 0.6)
												else
													self:SetAlpha(0)
												end
											else
											self:Hide()
											end

									else
									--Noflash
									end

								else
									if not (UnitName("target") == UnitName("player")) then
										self:Hide()
										ThreatAlert()
									else
									--ThreatAlert()
								end
									self:Hide()
								end
								self.elapsed = elapsed
							end)
							self.AggroFrame = aggro
						end
						self.AggroFrame:Show()
						
							--print("Aggro.")

							else
							--print("No Aggro.")
							end
							else
							--No Threat Alerts
							end
					
					else
					--Is nil
					end
				else
				--Not in Combat
				end
			else
			--Dont calculate Threat
			end
			
			if (playerName == targetTarget) then

				if not (target == playerName) then

					if (unitclass == "worldboss" or unitclass == "elite" or unitclass == "rareelite") then
					--Event
					if alarm then
					PlaySoundFile("Interface\\AddOns\\RWA\\assets\\alert.ogg")
					else
					--No Alarm Sound.
					end
					if beware then
					PlaySoundFile("Interface\\AddOns\\RWA\\assets\\beware.ogg")
					else
					--No Beware Sound.
					end
					
					if textNotice then
					RaidNotice_AddMessage(RaidWarningFrame, "Attacking You!", ChatTypeInfo["RAID_WARNING"])
					isAttackingYou = 1
					else
					--No Text Notice
					end

					--FlashFrame
					
					if flashing then
						if not self.FlashFrame then
						local flasher = CreateFrame("Frame", "RWAFlashFrame")
						flasher:SetToplevel(true)
						flasher:SetFrameStrata("FULLSCREEN_DIALOG")
						flasher:SetAllPoints(UIParent)
						flasher:EnableMouse(false)
						flasher:Hide()
						flasher.texture = flasher:CreateTexture(nil, "BACKGROUND")
						flasher.texture:SetTexture("Interface\\FullScreenTextures\\LowHealth")
						flasher.texture:SetAllPoints(UIParent)
						flasher.texture:SetBlendMode("ADD")
						flasher:SetScript("OnShow", function(self)
							self.elapsed = 0
							self:SetAlpha(0)
						end)
						flasher:SetScript("OnUpdate", function(self, elapsed)
							elapsed = self.elapsed + elapsed
							if elapsed < 2.6 then
								local alpha = elapsed % 1.3
								if alpha < 0.15 then
									self:SetAlpha(alpha / 0.15)
								elseif alpha < 0.9 then
									self:SetAlpha(1 - (alpha - 0.15) / 0.6)
								else
									self:SetAlpha(0)
								end
							else
								self:Hide()
							end
							self.elapsed = elapsed
						end)
						self.FlashFrame = flasher
					end
					self.FlashFrame:Show()
					else
					--No Flashing
					end					
					ONUPDATE_INTERVAL = 3
						frame:SetScript("OnHide", function(self, elapsed)
						TimeSinceLastUpdate = 1
						ONUPDATE_INTERVAL = 1
						end)
					
					end
					
				end

				else
				ONUPDATE_INTERVAL = 0.1
		end
	end



end)

-- When the frame is shown, reset the update timer
frame:SetScript("OnShow", function(self)
	TimeSinceLastUpdate = 0
end)
end


function RWA:OnDisable()
		self:Print("Warning Disabled")
end

